


#include <X11/Xlib.h>

#include <cni.h>
#include <java/lang/RuntimeException.h>
#include "no/rwr/x/Display.h"
#include "no/rwr/x/Colormap.h"
#include "no/rwr/x/XColor.h"


jlong no::rwr::x::Colormap::allocateColorPixel(XColor* color) {
    ::Display* dpy = (::Display*) (display->display);
    ::XColor* col = (::XColor*) (color->structure);
    Status result = XAllocColor(dpy, xid, col);
    if (result == 0) {
	JvThrow(new java::lang::RuntimeException(JvNewStringLatin1("Unable to allocate color pixel.")));
    }
    return col->pixel;
}
